//+------------------------------------------------------------------+
//|                                                  KurkaTrader.mq4 |
//|                                     Copyright  2006, KurkaFund. |
//|                                         http://www.kurkafund.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, KurkaFund."
#property link      "http://www.kurkafund.com"
#include <stdlib.mqh>

//---- input parameters
//trading parameters
extern int    MagicNumber  = 12345;
extern double Risk         = 0.2;              //percentage of AccountFreeMargin used to open position
extern double TrailingStop = 20;

extern double TakeProfitLow = 10;
extern double StopLossLow   = 20;
extern double TakeProfitMid = 20;
extern double StopLossMid   = 30;
extern double TakeProfitHigh= 30;
extern double StopLossHigh  = 40;

extern double SignalCandle = 1;

extern bool   TradeLowTrends   = true;
extern bool   TradeMidTrends   = true;
extern bool   TradeHighTrends  = true;

extern bool   UseOSMA          = true;
extern int    OSMAFast         = 5;
extern int    OSMASlow         = 30;
extern double OSMASignal       = 2;

extern bool   UseCCI           = true;
extern int    CCIPrice         = 0;    // 0 = Close price; 1 = Open price; 2 = High price; 3 = Low price; 4 = Median price, 5 = Typical price; 6 = Weighted close price
extern int    CciPer           = 18;
extern int    Cci_Level1       = 50;
extern int    Cci_Level2       = 100;
extern int    Cci_Level3       = 150;

extern bool   UseStoch         = true;
extern double StochHigh        = 75;
extern double StochLow         = 25;

extern bool   UseSar           = true;
extern double SarStep          = 0.02;
extern double SarMax           = 0.2;

extern bool   UseHighLow       = true;
extern int    HighPeriods      = 4;
extern int    HighPips         = 3;
extern int    HighStep         = 2;

extern bool   UseTrend         = true;
extern int    MAMode           = 2;    // 0 = simple; 1 = Exponential; 2 = Smoothed; 3 = linear weighted;
extern int    MAPrice          = 5;    // 0 = Close price; 1 = Open price; 2 = High price; 3 = Low price; 4 = Median price, 5 = Typical price; 6 = Weighted close price
extern double Trend_Strength_1 = 0.25; //Multiplies Lots for entry based on sum of true trend strength. 
extern double Trend_Strength_2 = 0.25;
extern double Trend_Strength_3 = 0.5;
extern double Trend_Strength_4 = 0.5;
extern double Trend_Strength_5 = 1;
extern double Trend_Strength_6 = 1;
extern int    Ema_1            = 8;
extern int    Ema_2            = 24;
extern int    Ema_3            = 72;
extern int    Ema_4            = 216;
extern int    EmaShift         = 0;







int start()
{
 if(Bars<Ema_4)
 {
 Print("Not Enough Bars");
 return(0); 
 } 
 if(AccountFreeMargin()<(1000))
 {
  Print("No Money. FreeMargin=",AccountFreeMargin());
  return(0);
 }

 

if (UseTrend){
  //Trend EMA's
  double Ema1 = iMA(NULL,0,Ema_1, 0,MAMode, PRICE_CLOSE, EmaShift+SignalCandle);
  double Ema2 = iMA(NULL,0,Ema_2, 0,MAMode, PRICE_CLOSE, EmaShift+SignalCandle);
  double Ema3 = iMA(NULL,0,Ema_3, 0,MAMode, PRICE_CLOSE, EmaShift+SignalCandle);
  double Ema4 = iMA(NULL,0,Ema_4, 0,MAMode, PRICE_CLOSE, EmaShift+SignalCandle);

//Up Trend Calcs

double up1 = 0; if (Ema1 > Ema2){ 
                  up1 = Trend_Strength_1; 
                  }
double up2 = 0; if ((Ema1 > Ema2) && (Ema1 > Ema3)){
                  up2 = Trend_Strength_2; 
                  }
double up3 = 0; if ((Ema1 > Ema2) && (Ema1 > Ema3) && (Ema1 > Ema4)){
                  up3 = Trend_Strength_3;
                  }
double up4 = 0; if ((Ema1 > Ema2) && (Ema1 > Ema3) && (Ema1 > Ema4) && (Ema2 > Ema3)){
                  up4 = Trend_Strength_4;
                  }
double up5 = 0; if ((Ema1 > Ema2) && (Ema1 > Ema3) && (Ema1 > Ema4) && (Ema2 > Ema3) && (Ema2 > Ema4)){
                  up5 = Trend_Strength_5;
                  }
double up6 = 0; if ((Ema1 > Ema2) && (Ema1 > Ema3) && (Ema1 > Ema4) && (Ema2 > Ema3) && (Ema2 > Ema4) && (Ema3 > Ema4)){
                  up6 = Trend_Strength_6; 
                  }

//Down Trend Calcs
double down1 = 0; if (Ema1 < Ema2){
                 down1 = Trend_Strength_1;
                 } 
double down2 = 0; if ((Ema1 < Ema2) && (Ema1 < Ema3)){
                 down1 = Trend_Strength_2; 
                 }
double down3 = 0; if ((Ema1 < Ema2) && (Ema1 < Ema3) && (Ema1 < Ema4)){
                 down1 = Trend_Strength_3; 
                 }
double down4 = 0; if ((Ema1 < Ema2) && (Ema1 < Ema3) && (Ema1 < Ema4) && (Ema2 < Ema3)){
                 down1 = Trend_Strength_4; 
                 }
double down5 = 0; if ((Ema1 < Ema2) && (Ema1 < Ema3) && (Ema1 < Ema4) && (Ema2 < Ema3) && (Ema2 < Ema4)){
                 down1 = Trend_Strength_5;
                 } 
double down6 = 0; if ((Ema1 < Ema2) && (Ema1 < Ema3) && (Ema1 < Ema4) && (Ema2 < Ema3) && (Ema2 < Ema4) && (Ema3 < Ema4)){
                 down1 = Trend_Strength_6;
                 } 

//Trend truths used to turn indicators on and off 0=off 1=on
bool up_1 = false; if (up1 > 0) {up_1 = true;return;}
bool up_2 = false; if (up2 > 0) {up_2 = true;return;}
bool up_3 = false; if (up3 > 0) {up_3 = true;return;}
bool up_4 = false; if (up4 > 0) {up_4 = true;return;}
bool up_5 = false; if (up5 > 0) {up_5 = true;return;}
bool up_6 = false; if (up6 > 0) {up_6 = true;return;}
bool down_1 = false; if (down1 > 0) {down_1 = true;return;}
bool down_2 = false; if (down2 > 0) {down_2 = true;return;}
bool down_3 = false; if (down3 > 0) {down_3 = true;return;}
bool down_4 = false; if (down4 > 0) {down_4 = true;return;}
bool down_5 = false; if (down5 > 0) {down_5 = true;return;}
bool down_6 = false; if (down6 > 0) {down_6 = true;return;}

}
//===================== Signals ==========================

//====================== OSMA ===========================
 bool OSMABUY  = false;
 bool OSMASELL = false;
 bool OSMAUP   = false;
 bool OSMADOWN = false;

if (UseOSMA){
            double OSMAPrev=iOsMA(NULL,0,OSMASlow,OSMAFast,OSMASignal,PRICE_CLOSE,SignalCandle+1);
            double OSMA=iOsMA(NULL,0,OSMASlow,OSMAFast,OSMASignal,PRICE_CLOSE,SignalCandle);
            
            if (OSMA > OSMAPrev) {OSMABUY = true;}
            if (OSMA < OSMAPrev) {OSMASELL = true;}
            if (OSMA > 0)        {OSMAUP = true;}
            if (OSMA < 0)        {OSMADOWN = true;}
            }
else {
  OSMABUY  = true;
  OSMASELL = true;
  OSMAUP   = true;
  OSMADOWN = true;
}
 
//====================== CCI ===========================

bool CCIBUY  = false;
bool CCISELL = false;
bool CCIUP   = false;
bool CCIDOWN = false; 

if (UseCCI){
            double CCI          = iCCI(NULL,0,CciPer,CCIPrice,SignalCandle);
            double CCIPrevious  = iCCI(NULL,0,CciPer,CCIPrice,SignalCandle+1);
                  
            if (CCI > Cci_Level1 && CCIPrevious <= Cci_Level1)    {CCIBUY  = true;}
            if (CCI > Cci_Level2 && CCIPrevious <= Cci_Level2)    {CCIBUY  = true;}
            if (CCI > Cci_Level3 && CCIPrevious <= Cci_Level3)    {CCIBUY  = true;}
            if (CCI < Cci_Level1 && CCIPrevious >= (-Cci_Level1)) {CCISELL = true;}
            if (CCI < Cci_Level2 && CCIPrevious >= (-Cci_Level2)) {CCISELL = true;}
            if (CCI < Cci_Level3 && CCIPrevious >= (-Cci_Level3)) {CCISELL = true;}
            }
else{
  CCIBUY  = true;
  CCISELL = true;
  CCIUP   = true;
  CCIDOWN = true;
}
//====================== Stoch ===========================

bool STOCHBUY  = false;
bool STOCHSELL = false;
bool STOCHUP   = false;
bool STOCHDOWN = false;

if (UseStoch){
              double Stoc            = iCustom(NULL, 0, "Zerolagstochs", 0,SignalCandle);
              double StocSignal      = iCustom(NULL, 0, "Zerolagstochs", 1,SignalCandle);
              double StocPrev        = iCustom(NULL, 0, "Zerolagstochs", 0,SignalCandle+1);  
              double StocPrevSignal  = iCustom(NULL, 0, "Zerolagstochs", 1,SignalCandle+1);
            
              if (Stoc > StocSignal && StocPrev <= StocPrevSignal && Stoc < StochLow)  {STOCHBUY  = true;}
              if (Stoc < StocSignal && StocPrev >= StocPrevSignal && Stoc > StochHigh) {STOCHSELL = true;}
              if (Stoc > StocSignal)                                                   {STOCHUP   = true;}
              if (Stoc < StocSignal)                                                   {STOCHDOWN = true;}
              }

else{
  STOCHBUY  = true;
  STOCHSELL = true;
  STOCHUP   = true;
  STOCHDOWN = true;
}

//========================= SAR ==========================================

bool SARBUY  = false;
bool SARSELL = false;
bool SARUP   = false;
bool SARDOWN = false;

if (UseSar){
             double SarCurrent    = iSAR(NULL, 0, SarStep, SarMax, SignalCandle);
             double SarPrevious   = iSAR(NULL, 0, SarStep, SarMax, SignalCandle+1);
             
             if (SarCurrent <= Ask && SarPrevious>SarCurrent) {SARBUY  = true;}
             if (SarCurrent >= Bid && SarPrevious<SarCurrent) {SARSELL = true;}
             if (SarCurrent <= Ask)                           {SARBUY  = true;}
             if (SarCurrent >= Bid)                           {SARSELL = true;}
             }
             
else{
  SARBUY  = true;
  SARSELL = true;
  SARUP   = true;
  SARDOWN = true;           
}


 /* /============================== High Low ====================================
 bool HIGHBUY  = false;
 bool HIGHSTEP = false;
 bool LOWBUY   = false;
 
 if(UseHighLow){
            double HighPoint    = iHigh(NULL,0,SignalCandle)
            int    HighestPoint = Highest(NULL,0,2,HighPeriods,SignalCandle
            double HighCurrent  = iHigh(NULL,0,0)
            
            
            
            double LowPoint  = iLow(NULL,0,SignalCandle)
            double HighBuy   = iHigh(NULL,0,0)
            double LowBuy    = iLow(NULL,0,0)
          
            if (HighCurrent <=(HighPoint - HighPips)) {HIGHBUY = true; HIGHSTEP=true;}
            if (HIGHSTEP){
              if (HighCurrent <= HighPoint - HighPips - HighStep) 
            
            
            if (LowBuy >= (Lowpoint + LowPips))   {LOWBUY  = true;}
 
 
*/

//Long Positions
double Up_Trend_Score = (up1 + up2 + up3 + up4 + up5 + up6);
if (UseTrend==false){Up_Trend_Score = 1;}
double LongLots = NormalizeDouble(AccountFreeMargin()*(Up_Trend_Score*Risk)/1000.0,1);

if (TradeLowTrends){
  if ((up_1==true || up_2==true) && up_3==false && up_4==false && up_5==false && up_6==false ){
    if (STOCHBUY == true && OSMAUP == true && OSMABUY == true && SARBUY == true){
      OrderSend(Symbol(),OP_BUY,LongLots,Ask,3,Ask-StopLossLow*Point,Ask+TakeProfitLow*Point,"Go Long Low Trend",MagicNumber,0,Green);
      return(0);
      }
     }
    } 
if (TradeMidTrends){
  if ((up_3==true || up_4==true) && up_5==false && up_6==false){
    if (CCIBUY == true && OSMABUY == true){
      OrderSend(Symbol(),OP_BUY,LongLots,Ask,3,Ask-StopLossMid*Point,Ask+TakeProfitMid*Point,"Go Long Mid Trend",MagicNumber,0,Green);
      return(0);
      }
     }
    }
if (TradeHighTrends){
  if (up_5==true || up_6==true ){
    if ((OSMAUP == true && OSMABUY == true)||(CCIBUY == true && OSMABUY == true)||(STOCHBUY == true && OSMAUP == true)||
       (SARBUY  == true)){
       OrderSend(Symbol(),OP_BUY,LongLots,Ask,3,Ask-StopLossHigh*Point,Ask+TakeProfitHigh*Point,"Go Long High Trend",MagicNumber,0,Green);
       return(0);
       }
      }
     }
//Short Positions 
 
double Down_Trend_Score = (down1 + down2 + down3 + down4 + down5 + down6);
if (UseTrend==false){Down_Trend_Score = 1;}
double ShortLots = NormalizeDouble(AccountFreeMargin()*(Down_Trend_Score*Risk)/1000.0,1);

if (TradeLowTrends){
  if ((down_1==true || down_2==true) && down_3==false && down_4==false && down_5==false && down_6==false ){
    if (STOCHSELL == true && OSMADOWN == true && OSMASELL == true && SARSELL == true){
      OrderSend(Symbol(),OP_SELL,ShortLots,Bid,3,Bid+StopLossLow*Point,Bid-TakeProfitLow*Point,"Go Short Low Trend",MagicNumber,0,Green);
      return(0);
      }
     }
    }  
if (TradeMidTrends){
  if ((down_3==true || down_4==true) && down_5==false && down_6==false){
    if (CCISELL == true && OSMASELL == true){
      OrderSend(Symbol(),OP_SELL,ShortLots,Bid,3,Bid+StopLossMid*Point,Bid-TakeProfitMid*Point,"Go Short Mid Trend",MagicNumber,0,Green);
      return(0);
      }
     }
    }  
if (TradeHighTrends){  
  if (down_5==true || down_6==true ){
    if ((OSMAUP == true && OSMABUY == true)||(CCIBUY == true && OSMABUY == true)||(STOCHBUY == true && OSMAUP == true)||
       (SARBUY  == true)){
       OrderSend(Symbol(),OP_SELL,ShortLots,Bid,3,Bid+StopLossHigh*Point,Bid-TakeProfitHigh*Point,"Go Short Mid Trend",MagicNumber,0,Green);
       return(0);
       }
      }
     }

return(0);
}